import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Query,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import HttpError from "../interfaces/http-error";
import HttpStatus from "../interfaces/http-status";
import HttpSuccess from "../interfaces/http-success";
import { AppDataSource } from "../database/data-source";
import { Profile } from "../entities/Profile";
import { CreateProfileEdit, EditProfileEdit, ProfileEdit } from "../entities/ProfileEdit";
import { RequestWithUser } from "../middlewares/user";
import { Brackets } from "typeorm";
import CallAPI from "../interfaces/call-api";
import permission from "../interfaces/permission";
import { OrgRevision } from "../entities/OrgRevision";
import { OrgRoot } from "../entities/OrgRoot";
import { PosMaster } from "../entities/PosMaster";
@Route("api/v1/org/profile/edit")
@Tags("ProfileEdit")
@Security("bearerAuth")
export class ProfileEditController extends Controller {
  private profileRepo = AppDataSource.getRepository(Profile);
  private profileEditRepo = AppDataSource.getRepository(ProfileEdit);
  private orgRevisionRepository = AppDataSource.getRepository(OrgRevision);
  private orgRootRepo = AppDataSource.getRepository(OrgRoot);
  private posMasterRepo = AppDataSource.getRepository(PosMaster);

  @Get("user")
  public async detailProfileEditUser(
    @Request() request: { user: Record<string, any> },
    @Query("page") page: number = 1,
    @Query("pageSize") pageSize: number = 10,
    @Query("keyword") keyword: string = "",
    @Query("status") status: string = "",
    @Query("sortBy") sortBy?: string,
    @Query("descending") descending?: boolean,
  ) {
    const profile = await this.profileRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }

    let query = await AppDataSource.getRepository(ProfileEdit)
      .createQueryBuilder("ProfileEdit")
      .leftJoinAndSelect("ProfileEdit.profile", "profile")
      .where((qb) => {
        if (status != "" && status != null) {
          qb.andWhere("ProfileEdit.status = :status", { status: status });
        }
        qb.andWhere("ProfileEdit.profileId = :profileId", { profileId: profile.id });
      })
      .andWhere(
        new Brackets((qb) => {
          qb.where(keyword != "" && keyword != null ? "ProfileEdit.topic LIKE :keyword" : "1=1", {
            keyword: `%${keyword}%`,
          })
            .orWhere(
              keyword != "" && keyword != null ? "ProfileEdit.detail LIKE :keyword" : "1=1",
              {
                keyword: `%${keyword}%`,
              },
            )
            .orWhere(
              keyword != "" && keyword != null ? "ProfileEdit.remark LIKE :keyword" : "1=1",
              {
                keyword: `%${keyword}%`,
              },
            );
        }),
      )
      .orderBy("ProfileEdit.createdAt", "DESC");

    if (sortBy) {
      query = query.orderBy(`ProfileEdit.${sortBy}`, descending ? "DESC" : "ASC");
    }

    const [getProfileEdit, total] = await query
      .skip((page - 1) * pageSize)
      .take(pageSize)
      .getManyAndCount();

    const _data = getProfileEdit.map((item) => ({
      id: item.id,
      topic: item.topic,
      detail: item.detail,
      status: item.status,
      remark: item.remark,
      createdAt: item.createdAt,
      createdFullName: item.createdFullName,
      lastUpdatedAt: item.lastUpdatedAt,
      lastUpdateFullName: item.lastUpdateFullName,
      fullname:
        (item?.profile?.prefix ?? "") +
        "" +
        (item?.profile?.firstName ?? "") +
        " " +
        (item?.profile?.lastName ?? ""),
    }));
    return new HttpSuccess({ data: _data, total: total });
  }

  @Get("admin")
  public async detailProfileEditAdmin(
    @Request() request: RequestWithUser,
    @Query("page") page: number = 1,
    @Query("pageSize") pageSize: number = 10,
    @Query("keyword") keyword: string = "",
    @Query("status") status: string = "",
    @Query("sortBy") sortBy?: string,
    @Query("descending") descending?: boolean,
  ) {
    let data = await new permission().PermissionOrgList(request, "SYS_REGISTRY_OFFICER");
    const orgRevisionPublish = await this.orgRevisionRepository
      .createQueryBuilder("orgRevision")
      .where("orgRevision.orgRevisionIsDraft = false")
      .andWhere("orgRevision.orgRevisionIsCurrent = true")
      .getOne();
    let query = await AppDataSource.getRepository(ProfileEdit)
      .createQueryBuilder("ProfileEdit")
      .leftJoinAndSelect("ProfileEdit.profile", "profile")
      .leftJoinAndSelect("profile.current_holders", "current_holders")
      .leftJoinAndSelect("current_holders.orgRevision", "orgRevision")
      .where((qb) => {
        if (status != "" && status != null) {
          qb.andWhere("ProfileEdit.status = :status", { status: status });
        }
        qb.andWhere("ProfileEdit.profileId IS NOT NULL");
      })
      .andWhere(orgRevisionPublish ? `current_holders.orgRevisionId = :revisionId` : "1=1", {
        revisionId: orgRevisionPublish?.id,
      })
      .andWhere(
        data.root != undefined && data.root != null
          ? data.root[0] != null
            ? `current_holders.orgRootId IN (:...root)`
            : `current_holders.orgRootId is null`
          : "1=1",
        {
          root: data.root,
        },
      )
      .andWhere(
        data.child1 != undefined && data.child1 != null
          ? data.child1[0] != null
            ? `current_holders.orgChild1Id IN (:...child1)`
            // : `current_holders.orgChild1Id is ${data.privilege == "PARENT" ? "not null" : "null"}`
            : `current_holders.orgChild1Id is null`
          : "1=1",
        {
          child1: data.child1,
        },
      )
      .andWhere(
        data.child2 != undefined && data.child2 != null
          ? data.child2[0] != null
            ? `current_holders.orgChild2Id IN (:...child2)`
            : `current_holders.orgChild2Id is null`
          : "1=1",
        {
          child2: data.child2,
        },
      )
      .andWhere(
        data.child3 != undefined && data.child3 != null
          ? data.child3[0] != null
            ? `current_holders.orgChild3Id IN (:...child3)`
            : `current_holders.orgChild3Id is null`
          : "1=1",
        {
          child3: data.child3,
        },
      )
      .andWhere(
        data.child4 != undefined && data.child4 != null
          ? data.child4[0] != null
            ? `current_holders.orgChild4Id IN (:...child4)`
            : `current_holders.orgChild4Id is null`
          : "1=1",
        {
          child4: data.child4,
        },
      )
      .andWhere(
        new Brackets((qb) => {
          qb.where(keyword != "" && keyword != null ? "ProfileEdit.topic LIKE :keyword" : "1=1", {
            keyword: `%${keyword}%`,
          })
            .orWhere(
              keyword != "" && keyword != null ? "ProfileEdit.detail LIKE :keyword" : "1=1",
              {
                keyword: `%${keyword}%`,
              },
            )
            .orWhere(
              keyword != "" && keyword != null ? "ProfileEdit.remark LIKE :keyword" : "1=1",
              {
                keyword: `%${keyword}%`,
              },
            )
            .orWhere(
              keyword != "" && keyword != null
                ? "CONCAT(profile.prefix, profile.firstName, ' ', profile.lastName) LIKE :keyword"
                : "1=1",
              {
                keyword: `%${keyword}%`,
              },
            );
        }),
      )
      .orderBy("ProfileEdit.createdAt", "DESC");

    if (sortBy) {
      if (sortBy == "fullname") {
        query = query.orderBy(`profile.firstName`, descending ? "DESC" : "ASC");
      } else {
        query = query.orderBy(`ProfileEdit.${sortBy}`, descending ? "DESC" : "ASC");
      }
    }

    const [getProfileEdit, total] = await query
      .skip((page - 1) * pageSize)
      .take(pageSize)
      .getManyAndCount();

    const _data = getProfileEdit.map((item) => ({
      id: item.id,
      idcard: item.profile.citizenId,
      profileId: item.profile.id,
      topic: item.topic,
      detail: item.detail,
      status: item.status,
      remark: item.remark,
      createdAt: item.createdAt,
      createdFullName: item.createdFullName,
      lastUpdatedAt: item.lastUpdatedAt,
      lastUpdateFullName: item.lastUpdateFullName,
      fullname:
        (item?.profile?.prefix ?? "") +
        "" +
        (item?.profile?.firstName ?? "") +
        " " +
        (item?.profile?.lastName ?? ""),
    }));
    return new HttpSuccess({ data: _data, total: total });
  }

  //   @Get("{Id}")
  //   public async detailProfileByIdEdit(@Path() Id: string) {
  //     const getProfileEdit = await this.profileEditRepo.findOne({
  //       where: { id: Id },
  //     });
  //     if (!getProfileEdit) {
  //       throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
  //     }
  //     return new HttpSuccess(getProfileEdit);
  //   }

  @Get("{id}")
  public async detailProfileEdit(@Path() id: string) {
    const getProfileEdit = await this.profileEditRepo.findOne({
      where: { id: id },
      relations: ["profile"],
    });
    if (!getProfileEdit) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    let orgRoot: OrgRoot | null = null;
    if(getProfileEdit.profile) { 
      const empPosMaster = await this.posMasterRepo.findOne({
        where: {
          current_holderId: getProfileEdit.profile.id,
          orgRevision: { orgRevisionIsCurrent: true, orgRevisionIsDraft: false }
        },
        relations: { orgRevision: true }
      });
      if(empPosMaster) {
        orgRoot = await this.orgRootRepo.findOne({
          select: { isDeputy: true },
          where: { id: empPosMaster.orgRootId ?? "" }
        });
      }
    }
    const _data = {
      id: getProfileEdit.id,
      topic: getProfileEdit.topic,
      detail: getProfileEdit.detail,
      citizenId: getProfileEdit?.profile?.citizenId ?? "",
      status: getProfileEdit.status,
      remark: getProfileEdit.remark,
      createdAt: getProfileEdit.createdAt,
      createdFullName: getProfileEdit.createdFullName,
      lastUpdatedAt: getProfileEdit.lastUpdatedAt,
      lastUpdateFullName: getProfileEdit.lastUpdateFullName,
      fullname:
        (getProfileEdit?.profile?.prefix ?? "") +
        "" +
        (getProfileEdit?.profile?.firstName ?? "") +
        " " +
        (getProfileEdit?.profile?.lastName ?? ""),
      isDeputy: orgRoot?.isDeputy ?? false
    };
    return new HttpSuccess(_data);
  }

  @Post()
  public async newProfileEdit(@Request() req: RequestWithUser, @Body() body: CreateProfileEdit) {
    const profile = await this.profileRepo.findOne({
      relations: {
        posLevel: true,
        posType: true,
        current_holders: true
      },
      where: { 
        keycloak: req.user.sub,
        current_holders: {
          orgRevision: {
            orgRevisionIsCurrent: true,
            orgRevisionIsDraft: false
          }
        }
      }
    });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const orgRoot = await this.orgRootRepo.findOne({
      select: {
        id: true,
        isDeputy: true
      },
      where: {
        id: profile.current_holders.find(x => x.orgRootId)!.orgRootId ?? ""
      }
    })

    const data = new ProfileEdit();
    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    data.status = "PENDING";
    await this.profileEditRepo.save(data);

    await new CallAPI()
      .PostData(req, "/org/workflow/add-workflow", {
        refId: data.id,
        sysName: "REGISTRY_PROFILE",
        posLevelName: profile.posLevel.posLevelName,
        posTypeName: profile.posType.posTypeName,
        fullName: `${profile.prefix}${profile.firstName} ${profile.lastName}`,
        isDeputy: orgRoot?.isDeputy ?? false,
        orgRootId: orgRoot?.id ?? null
      })
      .catch((error) => {
        console.error("Error calling API:", error);
      });

    return new HttpSuccess(data.id);
  }

  @Patch("{editId}")
  public async editProfileEdit(
    @Body() requestBody: EditProfileEdit,
    @Request() req: RequestWithUser,
    @Path() editId: string,
  ) {
    // const record = await this.profileEditRepo.findOneBy({ id: editId });
    const record = await this.profileEditRepo.findOne({
      where: { id: editId },
    });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");

    Object.assign(record, requestBody);

    record.lastUpdateFullName = req.user.name;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdatedAt = new Date();
    await Promise.all([this.profileEditRepo.save(record)]);

    return new HttpSuccess();
  }

  @Delete("{editId}")
  public async deleteProfileEdit(@Path() editId: string) {
    const result = await this.profileEditRepo.delete({ id: editId });

    if (result.affected == undefined || result.affected <= 0)
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");

    return new HttpSuccess();
  }
}
